"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BabelAdapter = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const events_1 = require("events");
class BabelAdapter extends events_1.EventEmitter {
    constructor() {
        super();
        this.classesDirectory = path.join(__dirname);
        this.classes = {};
    }
    loadClasses() {
        return __awaiter(this, void 0, void 0, function* () {
            const adapterDirectories = fs.readdirSync(this.classesDirectory).filter(dir => fs.statSync(path.join(this.classesDirectory, dir)).isDirectory() && dir.endsWith('Adapter'));
            for (const adapterDir of adapterDirectories) {
                const classNameOriginal = adapterDir;
                const className = adapterDir.replace('Adapter', '');
                const classFiles = fs.readdirSync(path.join(this.classesDirectory, adapterDir))
                    .filter(file => file.startsWith(`${className}Adapter`));
                const classFileName = classFiles[0];
                if (classFileName) {
                    const classFilePath = path.join(this.classesDirectory, adapterDir, classFileName);
                    if (fs.existsSync(classFilePath)) {
                        try {
                            const ClassModule = yield Promise.resolve(`${classFilePath}`).then(s => __importStar(require(s)));
                            this.classes[className] = ClassModule[classNameOriginal];
                        }
                        catch (error) {
                            console.error(`Failed to load class from ${classFilePath}:`, error);
                        }
                    }
                    else {
                        console.error(`Class file not found for ${className} in ${adapterDir}`);
                    }
                }
                else {
                    console.error(`No class file found for ${className} in ${adapterDir}`);
                }
            }
        });
    }
    watchForChanges() {
        fs.watch(this.classesDirectory, (eventType, filename) => {
            if (eventType === 'rename' && (filename === null || filename === void 0 ? void 0 : filename.endsWith('Adapter'))) {
                this.loadClasses();
            }
        });
    }
    notifyClients(event, className, classDefinition) {
        console.log(`modulePath en notifyClients() : ${classDefinition}`);
        console.log('enviar caulquier cosa');
        const modddd = 'cualquier cosa';
    }
    reloadClasses() {
        return __awaiter(this, void 0, void 0, function* () {
            this.classes = {};
            yield this.loadClasses();
        });
    }
    getClass(className) {
        return this.classes[className];
    }
    getClasses() {
        return this.classes;
    }
}
exports.BabelAdapter = BabelAdapter;
//# sourceMappingURL=index.js.map